/*======================================================================*
 *		        						* 
 * TITLE:	MYACC -- LALR(1) parser generator for modula-2	        *
 *									*
 * FILE:	search.c - binary search in a table			*
 *									*
 * UPDATED:     July 5, 1987						*
 * AUTHOR: 	Werner Stanglow						*
 *								        *
 *======================================================================*/

#include "search.h"

bsearch(cp,tab,noelem)

char *cp;		/* string to be found	*/
TABLE tab[];	        /* table to be searched */
int noelem;		/* no of table elements */

{	register first = 0, last = noelem-1, mid = last/2;
	if (noelem < 1)
		return 0;
	for(;;)
	{	register x;
		if (!(x =strcmp(tab[mid].text,cp)))
			return tab[mid].value;
		else if (x < 0) 
			first = mid+1;
		else
			last = mid-1;
		if (last < first)
			return 0;
		else
			mid = (first + last ) / 2; 
		
	}
}

char *strsave(str) 
char *str;

{	char * help;
	extern char *strcpy();

	help = (char *) calloc(strlen(str)+1,sizeof(char));
	if (help)
	 	return strcpy(help,str);
	else
		return 0;
}
