# ifndef TOKEN_H

# define ENDFILE 0		/* EOF			*/
# define IDENTIFIER 	257	/* [A-Za-z][A-Za-z0-9]* */
# define C_IDENTIFIER 	258 	/* IDENTIFIER ':' 	*/
# define NUMBER		259	/* [0-9]+		*/
# define STRING 	260     /* modula 2     	*/

# define MARK 		261	/* %%			*/
# define TOKEN 		262	/* %token		*/
# define LEFT 		263	/* %left		*/
# define RIGHT 		264	/* %right		*/
# define BINARY 	265	/* %non			*/ 
# define PREC		266	/* %prec		*/
# define LCURLY		267	/* %{			*/
# define RCURLY 	268	/* %}           	*/
# define START 		269	/* %start		*/
# define TYPEDEF 	270	/* %type		*/
# define CASE 		271	/* %case		*/
# define IMPORTS 	272 	/* %imports		*/
# define END 		273 	/* %end			*/
# define LEX		274	/* %lex		        */
# define ERROR	 	275	/* %error		*/
# define KEY		276	/* %key			*/
# define INIT		277	/* %init		*/
# define DEFS 		278  	/* %defs		*/
# define isreserved(x)  ( (x>=MARK) && (x<=DEFS))
# define ERRORTOK       300     /* %...			*/

# define TOKEN_H
# endif

