/*======================================================================*
 *		        						* 
 * TITLE:	MYACC -- LALR(1) parser generator for modula-2	        *
 *									*
 * FILE:	key.h - table of myacc's keywords			*
 * 									*
 * DESCRIPTION: This table contains the keywords to be recognized by    *
 *		the scanner and the corrosponding value to be returned. *
 * 					        			* 
 * SEE ALSO:    token.h (for token definitions),			*
 *		search.h (for definition of search tables)		*
 * 					        			* 
 * UPDATED:     July 5, 1987						*
 * 					        			* 
 * AUTHOR: 	Werner Stanglow						*
 *								        *
 *======================================================================*/

#include "token.h"			/* token definitions */
	{ "case",	CASE 	},
	{ "defs" ,	DEFS 	},
	{ "end",	END 	},
	{ "imports",	IMPORTS },
	{ "init",	INIT	},
	{ "keyword",	KEY	},
	{ "left",	LEFT 	},
	{ "non",	BINARY 	},
	{ "prec",	PREC	},
	{ "right",	RIGHT 	},
	{ "start",	START   },
	{ "token",	TOKEN   },
	{ "type",	TYPEDEF }
